package server;
import classes.*;
import java.math.*;
import javax.jws.WebMethod;
import javax.jws.WebParam;
import javax.jws.WebService;
import javax.jws.soap.SOAPBinding;

@WebService(name = "pexasoftService")
@SOAPBinding (
         style = SOAPBinding.Style.DOCUMENT,
         use = SOAPBinding.Use.LITERAL,
         parameterStyle = SOAPBinding.ParameterStyle.WRAPPED
)
    
public class wsServer {

   @WebMethod
   public boolean registerToShop( 
     @WebParam
	 (name = "username") String username,  
	 @WebParam
	 (name = "password", targetNamespace = "")String password,
	 @WebParam
	 (name = "email", targetNamespace = "")String email,
	 @WebParam
	 (name = "phone", targetNamespace = "")String phone,
	 @WebParam
	 (name = "address", targetNamespace = "")String address,
     @WebParam
	 (name = "vorname", targetNamespace = "")String vorname,
	 @WebParam
	 (name = "nachname", targetNamespace = "")String nachname ){   
	return (new registerToShop(username, password, email, phone, address, vorname, nachname).getState());
   }
   
   @WebMethod 
   public int loginToShop( 
     @WebParam(name = "username") String username,  
     @WebParam(name = "password", targetNamespace = "")String password )  {
     Login login = new Login();
     if (login.loginToShop(username, password) == 0) {
    	 return login.getCustomerID();
     }   
     else { return -1; }
   }


   @WebMethod
   public String[] getCustomerData(
     @WebParam(name = "customerID", targetNamespace = "") String customerID) {
	   String result[] = new String[8];
	   Customer cust = new Customer(customerID);
	   result[0] = cust.getUserID();
	   result[1] = cust.getUserName();
	   result[2] = cust.getPassWord();
	   result[3] = cust.getEmailAddr();
	   result[4] = cust.getTel();
	   result[5] = cust.getAddress();
	   result[6] = cust.getPreName();
	   result[7] = cust.getSurName();
	   return result;
   }
   
   
   @WebMethod
   public Integer getProductCountInGroup(@WebParam(name = "group", targetNamespace="") String group) {
	   return (new Product().getProductCountInGroup(group));
   }
   
   @WebMethod
   public Integer[] getAllProductsForGroup(@WebParam(name = "group", targetNamespace="") String group) {
	   if (group.equals("os")) {
	     group = "Betriebssysteme";
	   }
	   
	   if (group.equals("multi")) {
		     group = "Multimedia";
	   }
	   
	   if (group.equals("digital")) {
		     group = "Digitalisierung";
	   }
	   
	   if (group.equals("learn")) {
		     group = "Lernen";
	   }
	   
	   if (group.equals("games")) {
		     group = "Spiele";
	   }
	   
	   if (group.equals("office")) {
		     group = "Anwendungssoftware";
	   }

	   return (new Product().getAllProductsForGroup(group));
   }
   
   @WebMethod
   public Integer[] getAllProducts() {
	  return(new Product().getAllProducts());   
   }
   
   @WebMethod
   public Integer[] getSearchProduct(@WebParam(name = "searchstring", targetNamespace="") String searchstring) {
	  return(new Product().getSearchProduct(searchstring));   
   }
   
   @WebMethod
   public Integer[] getAllOrdersForCustomer(@WebParam(name = "customer", targetNamespace="") Integer customer) {
	  return(new Order().getAllOrdersForCustomer(customer));   
   }
   
   @WebMethod
   public String[] getOrderForCustomer(@WebParam(name = "order", targetNamespace="") Integer orderID) {
	  return(new Order().getOrderForCustomer(orderID));   
   }
   
   @WebMethod
   public String getProductDescription(@WebParam(name = "productID", targetNamespace="") Integer productID) {
	  return(new Product().getProductDescription(productID));   
   }
   
   @WebMethod
   public Integer setOrderForCustomer(
     @WebParam(name = "orderID", targetNamespace="") Integer[] productIDs,
     @WebParam(name = "userID", targetNamespace="") String userID){
	   Integer Nummer = new DatabaseWrite().getBestellNummer("bestellung");
	   DatabaseRead dbinfo = new DatabaseRead();
	   
	   Order order = new Order(userID, productIDs, Nummer);
	   String customerData[] = new DatabaseRead().getUserData(userID);
	   String bestellung[] = new DatabaseRead().getOrderForCustomer(Nummer);
	   String userName = customerData[1];
	   String vorname = customerData[6];
	   String nachname = customerData[7];
	   String subject = "pexaSoft Order Confirmation";
	   String message = "You, "+ userName + " , " + vorname + " " + nachname +" have ordered Following Items: \n" +
	   					"Order Number: "+Nummer +" \n" +
	   					"----------------------------\n";
	   double gesamtPreis = 0;
	   for (int i=0; i < bestellung.length; i+=2) {
		   String Hersteller = dbinfo.getProductVendor(Integer.valueOf(bestellung[i]).intValue());
		   String Name = dbinfo.getProductName(Integer.valueOf(bestellung[i]).intValue());
		   String Platform = dbinfo.getProductPlatform(Integer.valueOf(bestellung[i]).intValue());
		   double Price=dbinfo.getProductPrice(Integer.valueOf(bestellung[i]).intValue());
		   gesamtPreis+=Price*Integer.valueOf(bestellung[i+1]).intValue();
		   message+= bestellung[i+1] + "x " + Hersteller + " " + Name + " " + Platform + " " + new BigDecimal(Price).setScale(2,BigDecimal.ROUND_HALF_UP) + "\n";
	   }
	   message+="Gesamtbetrag: " + gesamtPreis + " Euro \n"; 
	   					
	   String from = "orders@pexasoft.com";
	   try {
	    new SendMail("georg@unibuild.com", subject, message, from);	   
	   } catch (Exception e) {
		   e.printStackTrace();
	   }
	 return order.getStatus();
   }
   
   @WebMethod
   public void addCustomerToMailingList(@WebParam(name = "email", targetNamespace="") String email) {
	   String subject = "Welcome to the pexaSoft Mailinglist";
	   String message = "Hello "+email+" You have been added to our Mailinglist";
	   String from = "mailinglist@pexasoft.com";
	   try {
	    new SendMail("georg@unibuild.com", subject, message, from);	   
	   } catch (Exception e) {
		   e.printStackTrace();
	   }
   }
   
   @WebMethod
   public Integer getProductStock(
     @WebParam(name = "stock", targetNamespace="") Integer productID){
	  return (new Product().getProductStock(productID));
   }
   
   @WebMethod
   public double getProductPrice(
     @WebParam(name = "price", targetNamespace="") Integer productID){
	  return (new Product().getProductPrice(productID));
   }
   
   @WebMethod
   public String getProductAddDate(
     @WebParam(name = "productID", targetNamespace="") Integer productID){
	  return (new Product().getProductAddDate(productID));
   }
   
   @WebMethod
   public Integer[] getAllTopProducts() {
	  return (new Product().getAllTopProducts());
   }
   
   @WebMethod
   public Integer[] getAllFreshProducts() {
	  return (new Product().getAllFreshProducts());
   }
   @WebMethod
   public String getProductVendor(
     @WebParam(name = "productID", targetNamespace="") Integer productID){
	  return (new Product().getProductVendor(productID));
   }
   
   @WebMethod
   public String getProductName(
     @WebParam(name = "productID", targetNamespace="") Integer productID){
	  return (new Product().getProductName(productID));
   }
   
   @WebMethod
   public String getCategoryForProduct(
     @WebParam(name = "productID", targetNamespace="") Integer productID){
	  return (new Product().getCategoryForProduct(productID));
   }
   
   @WebMethod
   public String getProductImg(
     @WebParam(name = "productID", targetNamespace="") Integer productID){
	  return (new Product().getProductImg(productID));
   }
   
   @WebMethod
   public String getProductPlatform(
     @WebParam(name = "productID", targetNamespace="") Integer productID){
	  return (new Product().getProductPlatform(productID));
   }
   
}	 
   